/**************************************************************************** 

CroatianSMS
Apple Widget To Send SMS To Croatian Cellphones (091 and 098)

Version: 1.1

Copyright (C) 2006 kaltar

kaltar@kaltar.org

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    
****************************************************************************/

/*********************************/
// GLOBAL CONFIGURATION
/*********************************/

// LCD Counter Gets RED When Number Of Chars Left Reach:
var min_chars_warning = 20;

// Max Number Of Chars In The SMS To Be Sent
var max_chars_in_SMS = 122;

/*********************************/
// BUTTONS ACTION
/*********************************/

function showSend(){
	document.getElementById('sendButton').src ='Images/send_pressed.png';
}
function hideSend(){
	document.getElementById('sendButton').src ='Images/send.png';
}

function showClear(){
	document.getElementById('clearButton').src ='Images/clear_pressed.png';
}
function hideClear(){
	document.getElementById('clearButton').src ='Images/clear.png';
}


function showDone(){
	document.getElementById('doneButton').src ='Images/done_pressed.png';
}
function hideDone(){
	document.getElementById('doneButton').src ='Images/done.png';
}


/***********************************/
// STRING FUNCTIONS
/***********************************/

// Removes leading whitespaces
function LTrim( value ){
	var re = /\s*((\S+\s*)*)/;
	return value.replace(re, "$1");
}

// Removes ending whitespaces
function RTrim( value ){
	var re = /((\s*\S+)*)\s*/;
	return value.replace(re, "$1");
}

// Removes leading and ending whitespaces
function trim( value ){
	return LTrim(RTrim(value));
}

// Removes Break Lines
function nobreak( value ){
	var re = /\n/;
	return value.replace(re, "");
}

// Remove Non Numbers
function filterNum(str) {
	var s = String(str);
	var n2 = String();
	for(var i = 0; i < s.length; i++) {
	   var ss = s.substr(i,1);
	   if(ss >= '0' && ss <= '9') { n2 = n2 + ss; }
	}
	return n2;
}




/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup(){

	if (AddressBookPlugin){
		AddressBookPlugin.LoadMobileNumbers();
		var addrBookPopup = document.getElementById("addrBookPopup");
		addrBookPopup.options = new Array();
		var numContacts = AddressBookPlugin.GetCount();
		for (var i = 0; i < numContacts; i++){
			addrBookPopup.options[i] = new Option(AddressBookPlugin.GetNameAtIndex(i),   AddressBookPlugin.GetMobileNumberAtIndex(i) );
		}
		addrBookPopup.options[numContacts] = new Option("*Unknown", "" );
		
		// Now To Sort Them
		arrTexts = new Array();
		for(i=0; i<addrBookPopup.length; i++)  {
			arrTexts[i]= new Array(2);
			arrTexts[i][0] = addrBookPopup.options[i].text;
			arrTexts[i][1] = addrBookPopup.options[i].value;
		}
		arrTexts.sort();
		for(i=0; i<addrBookPopup.length; i++)  {
			addrBookPopup.options[i].text = arrTexts[i][0];
			addrBookPopup.options[i].value = arrTexts[i][1];
		}
		
	}else{
		document.getElementById("SMSnumber").value = "AddrBook Err";
	}
	if(window.widget)	{// always check to make sure that you are running in Dashboard
		// The SMS Number 
		var SMSnumber_FromDisk  = widget.preferenceForKey("SMSnumber");
		if (SMSnumber_FromDisk  && SMSnumber_FromDisk.length > 0) { // if the retrieved preferences are not empty,
			document.getElementById("SMSnumber").value = SMSnumber_FromDisk;
		}
		
		// The Email 
		var email_FromDisk  = widget.preferenceForKey("email");
		if (email_FromDisk  && email_FromDisk.length > 0){
			document.getElementById("email").value = email_FromDisk;
		}		
		// The Network
		var network_FromDisk  = widget.preferenceForKey("network");
		if (network_FromDisk){
			document.getElementById("network").selectedIndex = parseInt(network_FromDisk);
		}		
		// The addrBookPopup
		var addrBookPopup_FromDisk  = widget.preferenceForKey("addrBookPopup");
		if (addrBookPopup_FromDisk){
			document.getElementById("addrBookPopup").selectedIndex = parseInt(addrBookPopup_FromDisk);
		}	
		// The dialing_to_person 
		var dialing_to_person_FromDisk  = widget.preferenceForKey("dialing_to_person");
		if (dialing_to_person_FromDisk  && dialing_to_person_FromDisk.length > 0){
			document.getElementById("dialing_to_person").innerHTML = dialing_to_person_FromDisk;
		}			
	}		
}


// Save() is called whenever a menu item is chosen in the widget's preferences.  It queries the
// menu to find out which option was chosen, applies the change to the widget, and saves the preference.

function save(){

	if(window.widget)	{
		widget.setPreferenceForKey(document.getElementById("SMSnumber").value,"SMSnumber");		// and save the new preference to disk
		widget.setPreferenceForKey(document.getElementById("email").value,"email");
		widget.setPreferenceForKey(document.getElementById("network").selectedIndex,"network");
		widget.setPreferenceForKey(document.getElementById("addrBookPopup").selectedIndex,"addrBookPopup");
		widget.setPreferenceForKey(document.getElementById("dialing_to_person").innerHTML,"dialing_to_person");
	}
} 



/*********************************/
// MAIN FUNCTIONS FOR THIS WIDGET
/*********************************/

var Sending = false;		// a flag used to signify if We Are Sending Right Now or Not.

// checkLength() Verifies That The Text On The LCD Doesnt Exceeds the Maximum Stablished
// It Also Refreshes the Counter (CharsLeft)
function checkLength(){
	if ( document.getElementById("lcd").value.length > max_chars_in_SMS){
		document.getElementById("lcd").value = document.getElementById("lcd").value.substring (0, max_chars_in_SMS);
	}
	CharsLeft = max_chars_in_SMS - document.getElementById("lcd").value.length;
	if (CharsLeft < 0){ CharsLeft = 0; }
	if (CharsLeft  > min_chars_warning){
		document.getElementById("CharsLeft").className='available_chars';
	} else{ 
		document.getElementById("CharsLeft").className='available_chars_red';
	}
	document.getElementById("CharsLeft").innerHTML = CharsLeft;
}

// ClearLCD() Clears The Form. 
function ClearLCD(){
	document.getElementById("lcd").value="";
	checkLength ();
}

function ShowFakeLCD(){
	document.getElementById("LCD_Holder_FAKE").style.display="block";
	document.getElementById("LCD_Holder").style.display="none";
}
function HideFakeLCD(){
	document.getElementById("LCD_Holder_FAKE").style.display="none";
	document.getElementById("LCD_Holder").style.display="block";
}

// Message() Display On The LCD A Message
function Message(msg,timer){
	document.getElementById("lcdfake").value = msg;
	ShowFakeLCD();
	setTimeout('hideSend();Sending=false;HideFakeLCD();', timer);
}


function ClearButtonAction(){
	if(!Sending){	
		showClear();
		ClearLCD();
		setTimeout("hideClear()", 100);
	}	
}


// SendSMS()  Sends the SMS Message.
function SendSMS(){
	if(!Sending){
		Sending=true;
		showSend(); // Mark The Button
		checkLength ();	
		
		if (document.getElementById("SMSnumber").value.length < 3){
			Message("\nInvalid cellphone number.",2000);
		} else if (trim(document.getElementById("email").value) == ""){
			Message("\nNo email entered.",2000);
		} else if (trim(document.getElementById("lcd").value) == ""){
			Message("\nCan't send empty message.",2000);
		} else{		
			// We encode the Parameters That We Need To Send...
			/*
			
			This Is The Ugly Hack =) Let's Use A Server that Allows A Post From any Location...
			
			SERVER: http://www.telfon.net/sms/smsmail.php     method: post
			
			poruka - 	Message Field 
			cronet  - SMS number to Send To Cronet Network 098
			vip - SMS number to Send To VIP Network 091
			email   - email of the person sending the email. (Since It's Not For Reply, I'll Add)
			wolf="pagex" - It's Requested, So Let's Send It.
			
			*/
	
			var URL_SMS_Server = 'http://www.telfon.net/sms/smsmail.php';
			
			// Lets See The Network Selected
			if ( document.getElementById("network").selectedIndex == 0 ){ // If Its VIP
				network_str = "vip=";
			} else { 
				network_str = "cronet=";
			}
			
			var parameters = "poruka=" + encodeURI( trim(document.getElementById("lcd").value) ) + 
							"&" + 		
							network_str + encodeURI( trim(document.getElementById("SMSnumber").value) ) +
							"&" +
							"email=" + encodeURI( trim(document.getElementById("email").value) ) +
							"&" +
							"wolf=" + encodeURI("pagex");
						
			// --------------------------------------
			http = new XMLHttpRequest();	
					
			http.open('POST', URL_SMS_Server , true);
			http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			http.setRequestHeader("Content-length", parameters.length);
			http.setRequestHeader("Connection", "close");
			http.send(parameters);
			// Show Results ...
			http.onreadystatechange = Confirmation;
			 
		}
		
	}	// If Not Sending
}

// Confirmation() Gets Confirmation From The Server And Prints The
// Possible Errors
function Confirmation(){
	if (http.readyState == 4){
		if (http.status == 200){
			// Verify That We Got Server Confirmation
			ServerReturn = http.responseText;
			// Here Its The Configuration For The Reception.
			// we Will Asume We Received It When It Returns
			// 098 1122345 poslano
			// So We Look For Our Number And Poslano Together In The Return
			if ( ServerReturn.indexOf(" poslano") != -1 ){
				Message("\n\n\n      SMS SENT",1700);
				ClearLCD();
			} else{
				Message("\nServer Error: \nSMS NOT SENT.",4000);
			}
		} else{
			Message("\nCould Not Contact Server.",4000);
		}
	}
}




function ForceNumber(){
	var num = String(filterNum(document.getElementById("SMSnumber").value));
	// First: CRONET - 098
	whereIS = num.indexOf("98");
	if(whereIS >=0 ){ // We Have The Number
		document.getElementById("SMSnumber").value = num.substring(whereIS+2,num.length );
		document.getElementById("network").selectedIndex = 1;
		save();
	}else{
		// Lets Try VIP
		whereIS = num.indexOf("91");
		if(whereIS >=0 ){ // We Have The Number
			document.getElementById("SMSnumber").value = num.substring(whereIS+2,num.length );
			document.getElementById("network").selectedIndex = 0;
			save();
		}	
	}
	
}


	
/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/


// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs(){
	
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	hideDone();
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('PrefsButtonOn').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs(){
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
	
}





// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation ={duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event){
	if (!flipShown) {			// if the preferences flipper is not already showing...
		if (animation.timer != null){		// reset the animation timer value, in case a value was left behind
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('led');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event){
	if (flipShown){
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('led');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate(){
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration){
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}else{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c){
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease){
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event){
	document.getElementById('PrefsButtonOn').style.display = 'block';
}

function exitflip(event){
	document.getElementById('PrefsButtonOn').style.display = 'none';
}

function	SelectFromAddressBook(){
	var	selectedIndex;

	selectedIndex = document.getElementById('addrBookPopup').options.selectedIndex;
	document.getElementById("SMSnumber").value = document.getElementById('addrBookPopup').options[selectedIndex].value;
	var nd = String(document.getElementById('addrBookPopup').options[selectedIndex].text);
	if ( nd.length > 25){
		nd = nd.substring (0, 25) + "...";
	}
	document.getElementById("dialing_to_person").innerHTML = "to: " + nd ;
	save();
	
}

function ClearAddressbook(){
	document.getElementById('addrBookPopup').options.selectedIndex=0;
	document.getElementById("dialing_to_person").innerHTML = "to: *Unknown";
	save();	
}

